﻿using System;
using System.Web.Mvc;

using Demo1.Infrastructure;
using Demo1.Models;
using Mindscape.LightSpeed;

namespace Demo1.Controllers
{
  public class TaskController : BaseController, IDisposable
  {
    public void Index()
    {
      RenderView("Index");
    }

    public void New()
    {
      TaskViewData tvd = new TaskViewData();

      tvd.AllPeople = Repository.Find<Person>();
      tvd.AllProjects = Repository.Find<Project>();

      RenderView("New", tvd);
    }

    public void Create(string subject, string notes, int projectId, int personId)
    {
      Task task = new Task();
      task.Subject = subject;
      task.Notes = notes;
      task.PersonId = personId;
      task.ProjectId = projectId;

      Repository.Add(task);
      Repository.CompleteUnitOfWork();

      RedirectToAction("Index");
    }

    public void Detail(int id)
    {
      TaskViewData viewData = new TaskViewData();

      viewData.Task = Repository.FindOne<Task>(id);

      RenderView("Detail", viewData);
    }

    /// <summary>
    /// NonAction will prevent this method being called from a URL.
    /// </summary>
    [NonAction]
    public void Dispose()
    {
      Repository.CompleteUnitOfWork();
    }
  }
}
