﻿using System.Web.Mvc;

namespace Demo1.Infrastructure
{
  /// <summary>
  /// This base controller is ugly and is provided only to help
  /// highlight the benefits of mocking in the test project.
  /// </summary>
  public class BaseController : Controller
  {
    public string LastRenderView{ get; private set; }

    protected new void RenderView(string viewName)
    {
      LastRenderView = viewName;

      base.RenderView(viewName);
    }

    protected new void RenderView(string viewName, object viewData)
    {
      LastRenderView = viewName;

      base.RenderView(viewName, viewData);
    }
  }
}