using System;

using Mindscape.LightSpeed;

namespace Demo1.Models
{
  [Serializable]
  public class Task : Entity<int>
  {
    private int _projectId;
    private int _personId;
    private string _subject;
    private string _notes;

    private readonly EntityHolder<Person> _person = new EntityHolder<Person>();
    private readonly EntityHolder<Project> _project = new EntityHolder<Project>();

    public Person AssignedTo
    {
      get { return Get(_person); }
    }

    public Project Project
    {
      get { return Get(_project); }
    }

    public int ProjectId
    {
      get { return _projectId; }
      set { SetValue(ref _projectId, value); }
    }

    public int PersonId
    {
      get { return _personId; }
      set { SetValue(ref _personId, value); }
    }

    public string Subject
    {
      get { return _subject; }
      set { SetValue(ref _subject, value); }
    }

    public string Notes
    {
      get { return _notes; }
      set { SetValue(ref _notes, value); }
    }
  }
}
