﻿using Demo1.Controllers;
using Demo1.Infrastructure;

using NUnit.Framework;

namespace Tests
{
  /// <summary>
  /// This test shows how you can create a mock manually. It's great if you have only
  /// one or two classes you wish to mock but becomes a maintence nightmare if you're
  /// going to mock many interfaces/classes as you'll need to maintain the mock classes
  /// </summary>
  
  [TestFixture]
  public class MockTests
  {
    [Test]
    public void ExpensiveCalculatorTest()
    {
      // Create a mock long running service
      ILongRunningService service = new MyService();
      PersonController controller = new PersonController(service);

      // Assert that our call functions happily
      Assert.AreEqual(1340, controller.DoComplexMaths(1, 2));
    }
  }

  public class MyService : ILongRunningService
  {
    #region ILongRunningService Members

    public int DoWork()
    {
      return 1337;
    }

    #endregion
  }
}