﻿using Demo1.Controllers;
using Demo1.Infrastructure;

using NUnit.Framework;

using Rhino.Mocks;

namespace Tests
{
  /// <summary>
  /// This mock test is similar to the manual mock test but uses Rhino Mocks to
  /// manage the mock classes. You can learn more about Rhino mocks here:
  /// http://www.ayende.com/projects/rhino-mocks/downloads.aspx
  /// </summary>
  
  [TestFixture]
  public class MockTests1
  {
    [Test]
    public void ExpensiveCalculatorTest()
    {
      // Create a mock repository
      MockRepository repository = new MockRepository();

      // Create a mock long running service
      ILongRunningService service = repository.DynamicMock<ILongRunningService>();

      PersonController controller = new PersonController(service);

      // Record our expectations
      using (repository.Record())
      {
        Expect.Call(service.DoWork()).Return(1337);
      }

      // Assert that our call functions happily
      Assert.AreEqual(1340, controller.DoComplexMaths(1, 2));

      // Ensure that our expectations have been met
      repository.ReplayAll();
      repository.VerifyAll();
    }
  }
}